/**********************************************************************
**  Copyright 2003 Craig Graham <craig@data-uncertain.co.uk>
**  Copyright 2003 Steve Essery <tecknobabble@hotmail.com>
**
**  This file is part of the SubApplet Applet.
**
**  The SubApplet Applet is free software; you can redistribute it
**  and/or modify it under the terms of the GNU General Public License
**  as published by the Free Software Foundation; either version 2 of
**  the License, or (at your option) any later version.
**
**  The SubApplet Applet is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**  GNU General Public License for more details.
**
**  You should have received a copy of the GNU General Public License
**  along with the SubApplet Applet; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**
**********************************************************************/

#ifndef _ABOUTFORM_H_
#define _ABOUTFORM_H_

#include <qevent.h>
#include <qdict.h>
#include <qstring.h>
#include <qstringlist.h>
#include <qlistview.h>
#include <qpixmap.h>

#include "about.h"
#include "subapplet.h"
#include "debug.h"

typedef QDict<QString> StringDict;

class AboutForm : public AboutFormBase
{
	Q_OBJECT
	
public:
    AboutForm(SubApplet *subapplet, QWidget *parent=0, const char *name=0, bool modal=false);
    ~AboutForm();
    void close();
    void checkGeometry(bool);

protected:
    //void showEvent(QShowEvent *);
    void accept();
    void reject();

protected slots:
    void setupTabContents(QWidget*);
    void drawCheckBoxChanged();
    void flatCheckBoxChanged();
    void debugCheckBoxChanged();
    void positionChanged(int);
    void resyncConfig();
    void rowClicked(QListViewItem *);
    void nameChanged();
    void moveRowUp();
    void moveRowDown();
    void sliderChanged(int);
    void toggleClicked(bool);

private:
    SubApplet  *subApplet;
    bool        mUseDrawButton;
    bool        mUseFlatButton;
    bool        mUseDebug;
    int         mPosition;
    int         mPopupDelay;
    StringDict  mLibNameDict;
    StringDict  mNiceNameDict;
    QStringList mLibNames;
    QStringList mNiceNames;
    QStringList mExcludeApplets;
    bool        mResyncConfig;
    bool        mUpdateMenuTab;
    DebugHelper mDebugHelper;
    QString     mOrigName;
    QPixmap     mOkPixmap;
    QPixmap     mCancelPixmap;
};

#endif // _ABOUTFORM_H_
