#include "debug.h"


DebugHelper::DebugHelper(char *file)
    : mDebugFlag(false), pFileName(file), pDebugFile(NULL) {}


DebugHelper::~DebugHelper()
{
    if (pDebugFile != (FILE*)NULL)
    {
        fflush(pDebugFile);
	fclose(pDebugFile);
    }
}


void DebugHelper::logMessage(const char* format, ...)
{
    if (mDebugFlag && pDebugFile != (FILE*)NULL)
    {
        va_list ap;
	va_start(ap, format);
	vfprintf(pDebugFile, format, ap);
	fprintf(pDebugFile, "\n");
	va_end(ap);
	fflush(pDebugFile);
    }
}

void DebugHelper::setDebugFlag(bool flag)
{
    mDebugFlag = flag;
    if (mDebugFlag)
    {
        if (pDebugFile == (FILE *)NULL && pFileName != NULL)
	{
	    pDebugFile = fopen(pFileName, "a+");
	}
    }
    else
    {
        if (pDebugFile != (FILE *)NULL)
	{
	    fflush(pDebugFile);
	    fclose(pDebugFile);
	    pDebugFile = NULL;
	}
    }
}

bool DebugHelper::debugFlag()
{
    return mDebugFlag;
}
