/**********************************************************************
**  Copyright 2003 Craig Graham <craig@data-uncertain.co.uk>
**  Copyright 2003 Steve Essery <tecknobabble@hotmail.com>
**
**  This file is part of the SubApplet Applet.
**
**  The SubApplet Applet is free software; you can redistribute it
**  and/or modify it under the terms of the GNU General Public License
**  as published by the Free Software Foundation; either version 2 of
**  the License, or (at your option) any later version.
**
**  The SubApplet Applet is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**  GNU General Public License for more details.
**
**  You should have received a copy of the GNU General Public License
**  along with the SubApplet Applet; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**
**********************************************************************/
#ifndef _SUBAPPLET_H_
#include "subapplet.h"
#endif
#ifndef _SUBAPPLETIMPL_H_
#include "subappletimpl.h"
#endif
#include <stdio.h>
#include <qpe/config.h>
#include <qdir.h>

SubAppletImpl::SubAppletImpl()
    : pSubApplet(0), ref(0), mPosition(10)
{
    QDir settingsDir(QDir::homeDirPath()+"/Settings");
    QString configFilePath(settingsDir.filePath("SubApplet.conf"));

    if (QFile::exists(configFilePath))
    {
        Config cfg(configFilePath, Config::File);
        cfg.setGroup("Settings");
	mPosition = cfg.readNumEntry("Position", 10);
    }
}

SubAppletImpl::~SubAppletImpl()
{
    delete pSubApplet;
}

QWidget *SubAppletImpl::applet( QWidget *parent )
{
    if ( !pSubApplet )
	pSubApplet = new SubApplet( parent );
    return pSubApplet;
}

int SubAppletImpl::position() const
{
    return mPosition;
}

#ifndef QT_NO_COMPONENT
QRESULT SubAppletImpl::queryInterface( const QUuid &uuid, QUnknownInterface **iface )
{
    *iface = 0;
    if ( uuid == IID_QUnknown )
	*iface = this;
    else if ( uuid == IID_TaskbarApplet )
	*iface = this;
    else
	return QS_FALSE;

    (*iface)->addRef();
    return QS_OK;
}

Q_EXPORT_INTERFACE()
{
    Q_CREATE_INSTANCE( SubAppletImpl )
}
#endif

